<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Coursework extends Controller_Handler_Map {

    public function before() {
        parent::before();

        $this->user->checkAccess(User::RIGHTS_TEACHER);
    }

    public function action_add() {
        $data['success'] = false;

        $subject =& $this->post['subjectID'];
        $subject = ($this->post['type'] == 'scientific') ? 346 : (int) $subject;

        $this->post
            ->rule('type', 'matches', [':validation', 'scientific', 'disciplinary'])
            ->rule('grade', 'not_empty')
            ->rule('grade', 'digit')
            ->rule('facultyID', 'not_empty')
            ->rule('facultyID', 'digit');

        if ($subject > 0 && $this->post->check()) {
            $discipline['id'] = Model_CourseWork::create([
                'faculty' => $this->post['facultyID'],
                'grade'   => $this->post['grade'],
                'teacher' => $this->user['TeacherID'],
                'semester'=> $this->user->SemesterID,
                'type'    => $this->post['type'],
                'subject' => $subject,
            ]);

            if ($discipline['id']) {
                // Attach all teachers of the department to coursework
                if ($this->post['type'] == 'scientific')
                    foreach (Model_Teachers::getTeachersByDepartment($this->user->DepID) as $teacher)
                        Model_Map::bindTeacher($this->user->TeacherID, $teacher['ID'], $discipline['id']);

                $module = Model_Map::addModule($this->user['TeacherID'], $discipline['id'], 'Курсовая работа')[0]['Num'];
                Model_Map::addSubmodule($this->user['TeacherID'], $module, 100, 'Отчёт', '', 'LandmarkControl');

                // Response to json client
                $data = [
                    'success' => true,
                    'id' => $discipline['id'],
                ];
            }
        }

        $this->response->body(json_encode($data));
    }
}